﻿package 
{
  import flash.display.Bitmap;
  import flash.display.BitmapData;
	import flash.display.DisplayObject;
	import flash.display.MovieClip;
  import flash.display.Shape;
  import flash.display.SimpleButton;
	import flash.display.StageAlign;
  import flash.display.StageQuality;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
  import flash.events.MouseEvent;
	import flash.events.ProgressEvent;
  import flash.text.TextField;
  import flash.ui.ContextMenu;
	import flash.utils.getDefinitionByName;
  import flash.display.Sprite;
	
  import flash.net.URLRequest;
  import flash.net.navigateToURL;

  
	public class Preloader extends MovieClip 
	{
		
		public function Preloader() 
		{
      

			
			// TODO show loader
     	if (stage) init();
  		else addEventListener(Event.ADDED_TO_STAGE, init);
		}//ctor
    
    public var top:Sprite;
    
    private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point
      
      bNoDebug = true;
      
//      stage.scaleMode =  StageScaleMode.NO_SCALE;
      stage.scaleMode = StageScaleMode.EXACT_FIT;
      stage.quality = StageQuality.LOW;
      
       var my_menu:ContextMenu = new ContextMenu();
       my_menu.builtInItems.forwardAndBack = false;
       my_menu.builtInItems.loop = false;
       my_menu.builtInItems.play = false;
       my_menu.builtInItems.print = false;
       my_menu.builtInItems.rewind = false;
       my_menu.builtInItems.zoom = false;
       my_menu.builtInItems.quality = false;
       contextMenu = my_menu;
      
      
      myAdvFont = new xAdvFont();
      myAdvFont.loadAscii((new embedPicAscii).bitmapData, 16, 16);
      
      var back:Bitmap;
      back = new embedPicLoading;
      back.scaleX = back.scaleY = 2;
      //back = new Bitmap(new BitmapData(640, 480));
      addChild(back);
      
      top = new Sprite();
      addChild(top);
      
      var btn:SimpleButton;
      
      btn = makeButton("PLAY!", 256, 48,0xFF0000);
      btn.x = 320;
      btn.y = 140 + 100;
      btn.visible = false;
      addChild(btn);
      btn.addEventListener(MouseEvent.CLICK, playPress);
      playBtn = btn;
      
      
      btn = makeButton("PLAY - NO SOUND PLEASE!", 512, 48, 0x808080);
      btn.x = 320;
      btn.y = 140 + 50 + 20 +100;// + 50 + 20;
      btn.visible = false;
      addChild(btn);
      btn.addEventListener(MouseEvent.CLICK, mutePlayPress);
      mutePlayBtn = btn;
      

      
     	addEventListener(Event.ENTER_FRAME, checkFrame);
			loaderInfo.addEventListener(ProgressEvent.PROGRESS, progress);
			loaderInfo.addEventListener(IOErrorEvent.IO_ERROR, ioError);
    }//init  
    

    public var myAdvFont:xAdvFont;
    
    public var playBtn:SimpleButton;
    public var mutePlayBtn:SimpleButton;
    
   
    [Embed(source = "ascii2.png")] private static var embedPicAscii:Class;
    [Embed(source = "loadingpic2.png")]  private static var embedPicLoading:Class;
  

    
    public static var bStartMute:Boolean = false;
    public static var bNoDebug:Boolean = false;

    private function playPress(e:MouseEvent):void
    {
      bStartMute = false;
      startup();
    }//playpress
    
    private function mutePlayPress(e:MouseEvent):void
    {
       bStartMute = true;
      startup();
    }//muteplay
    

   
		private function ioError(e:IOErrorEvent):void 
		{
			trace(e.text);
		}//ioerror
    	
    

   
    
		private function progress(e:ProgressEvent):void 
		{
      graphics.clear();
      top.graphics.clear();
    
      var ax:Number; var ay:Number;
      ax = 320; ay = 40;
      
      if (loaderInfo.bytesLoaded >= loaderInfo.bytesTotal)
      {
       myAdvFont.writeStrSpr(top.graphics, ax, ay, "GAME LOADED", null, 1);         
      }
      else
      {
       myAdvFont.writeStrSpr(top.graphics, ax, ay, "LOADING..", null, 1);
       
       myAdvFont.writeStrSpr(top.graphics, ax, ay+80, int(loaderInfo.bytesLoaded/1024).toString() + " KB of " + int(loaderInfo.bytesTotal/1024).toString() + " KB", null, 1, false);
   
      }
		}//progress
		
		private function checkFrame(e:Event):void 
		{
			if (currentFrame == totalFrames) 
			{
				stop();
				loadingFinished();
			}
		}//checkframe
		
		private function loadingFinished():void 
		{
			removeEventListener(Event.ENTER_FRAME, checkFrame);
			loaderInfo.removeEventListener(ProgressEvent.PROGRESS, progress);
			loaderInfo.removeEventListener(IOErrorEvent.IO_ERROR, ioError);
			
			// TODO hide loader
        playBtn.visible = true;
        mutePlayBtn.visible = true;
			
			//startup();
		}//loadfin
		
		private function startup():void 
		{
      //remember -- set xOverMenu as the document class
			var mainClass:Class = getDefinitionByName("Main") as Class;
			stage.addChild(new mainClass() as DisplayObject);
      visible = false;
		}//startup
    
    
    
    
    
    
    private function makeButton(str:String, bw:Number=256, bh:Number=48, c:uint = 0xFF ):SimpleButton
    {
      var shape:Shape;      var shape1:Shape;      var shape2:Shape;      var shape3:Shape;
      var shape4:Shape;
      
      var btn:SimpleButton;
      var i:int;
      
      for (i = 0; i < 4; i += 1)
      {
        shape = new Shape();
        shape.graphics.lineStyle(2, 0);
        shape.graphics.beginFill(c, i==1?0.75:0.5);
        shape.graphics.drawRoundRect( bw*-0.5, bh*-0.5, bw, bh, 8, 8);
        shape.graphics.endFill();
        shape.graphics.lineStyle();
        myAdvFont.writeStrSpr(shape.graphics, 0, -12, str, null, 1, false);
      
        if (i == 0) { shape1 = shape; }
        else if (i == 1) { shape2 = shape; shape.x -= 2; shape.y -= 2; }
        else if (i == 2) { shape3 = shape; shape.x += 2; shape.y += 2; }
        else if (i == 3) { shape4 = shape; }
      }//nexti
      
      
      btn = new SimpleButton(shape1, shape2, shape3, shape4);
      
      return btn;
    }//makebutton
    
    
    
    
    private function makeSkinButton(skin:BitmapData,bw:Number=-1,bh:Number=-1 ):SimpleButton
    {
      var shape:Shape;      var shape1:Shape;      var shape2:Shape;      var shape3:Shape;
      var shape4:Shape;
      var bw:Number; var bh:Number;
      var btn:SimpleButton;
      if (bw <= 0) { bw = skin.width; }
      if (bh <= 0) {bh = skin.height;}
      
      var i:int;
      
      for (i = 0; i < 4; i += 1)
      {
        shape = new Shape();
       // shape.graphics.lineStyle(2, 0);
        shape.graphics.beginBitmapFill(skin, null, false, true);
        shape.graphics.drawRect( 0,0, bw, bh);
        shape.graphics.endFill();
        shape.graphics.lineStyle();
        if (i == 0) { shape1 = shape; }
        else if (i == 1) { shape2 = shape; shape.x -= 1; shape.y -= 1; }
        else if (i == 2) { shape3 = shape; shape.x += 1; shape.y += 1; }
        else if (i == 3) { shape4 = shape; }
        
      }//nexti
      
 
      btn = new SimpleButton(shape1, shape2, shape3, shape4);
      
      return btn;
    }//makeskinbutton
    
    
		
	}//classend
	
}